use sts_map_oracle::dump_map;
use sts_map_oracle::format_map;
use sts_map_oracle::generate_maps;

const MAP_HEIGHT: i32 = 15;
const MAP_WIDTH: i32 = 7;
const PATH_DENSITY: i32 = 6;
const IS_ASCENSION_ZERO: bool = false;

#[test]
fn check_json_for_readme_example() {
    let seed = 673465884448;
    let maps = generate_maps(seed, MAP_HEIGHT, MAP_WIDTH, PATH_DENSITY, IS_ASCENSION_ZERO);
    assert_eq!(
        dump_map(&maps[0]),
        r#"{"edges":[{"src_x":0,"src_y":0,"dst_x":1,"dst_y":1},{"src_x":2,"src_y":0,"dst_x":3,"dst_y":1},{"src_x":5,"src_y":0,"dst_x":4,"dst_y":1},{"src_x":1,"src_y":1,"dst_x":0,"dst_y":2},{"src_x":3,"src_y":1,"dst_x":2,"dst_y":2},{"src_x":3,"src_y":1,"dst_x":3,"dst_y":2},{"src_x":3,"src_y":1,"dst_x":4,"dst_y":2},{"src_x":4,"src_y":1,"dst_x":5,"dst_y":2},{"src_x":0,"src_y":2,"dst_x":1,"dst_y":3},{"src_x":2,"src_y":2,"dst_x":3,"dst_y":3},{"src_x":3,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":4,"src_y":2,"dst_x":5,"dst_y":3},{"src_x":5,"src_y":2,"dst_x":6,"dst_y":3},{"src_x":1,"src_y":3,"dst_x":1,"dst_y":4},{"src_x":3,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":5,"dst_y":4},{"src_x":5,"src_y":3,"dst_x":6,"dst_y":4},{"src_x":6,"src_y":3,"dst_x":6,"dst_y":4},{"src_x":1,"src_y":4,"dst_x":0,"dst_y":5},{"src_x":3,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":3,"src_y":4,"dst_x":4,"dst_y":5},{"src_x":5,"src_y":4,"dst_x":6,"dst_y":5},{"src_x":6,"src_y":4,"dst_x":6,"dst_y":5},{"src_x":0,"src_y":5,"dst_x":1,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":2,"dst_y":6},{"src_x":4,"src_y":5,"dst_x":5,"dst_y":6},{"src_x":6,"src_y":5,"dst_x":5,"dst_y":6},{"src_x":6,"src_y":5,"dst_x":6,"dst_y":6},{"src_x":1,"src_y":6,"dst_x":1,"dst_y":7},{"src_x":2,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":5,"src_y":6,"dst_x":4,"dst_y":7},{"src_x":5,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":6,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":6,"src_y":6,"dst_x":6,"dst_y":7},{"src_x":1,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":2,"dst_y":8},{"src_x":4,"src_y":7,"dst_x":5,"dst_y":8},{"src_x":5,"src_y":7,"dst_x":5,"dst_y":8},{"src_x":6,"src_y":7,"dst_x":6,"dst_y":8},{"src_x":1,"src_y":8,"dst_x":1,"dst_y":9},{"src_x":2,"src_y":8,"dst_x":2,"dst_y":9},{"src_x":5,"src_y":8,"dst_x":5,"dst_y":9},{"src_x":5,"src_y":8,"dst_x":6,"dst_y":9},{"src_x":6,"src_y":8,"dst_x":6,"dst_y":9},{"src_x":1,"src_y":9,"dst_x":1,"dst_y":10},{"src_x":2,"src_y":9,"dst_x":3,"dst_y":10},{"src_x":5,"src_y":9,"dst_x":4,"dst_y":10},{"src_x":5,"src_y":9,"dst_x":5,"dst_y":10},{"src_x":6,"src_y":9,"dst_x":6,"dst_y":10},{"src_x":1,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":3,"dst_y":11},{"src_x":4,"src_y":10,"dst_x":4,"dst_y":11},{"src_x":5,"src_y":10,"dst_x":5,"dst_y":11},{"src_x":6,"src_y":10,"dst_x":5,"dst_y":11},{"src_x":1,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":3,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":4,"src_y":11,"dst_x":4,"dst_y":12},{"src_x":5,"src_y":11,"dst_x":5,"dst_y":12},{"src_x":5,"src_y":11,"dst_x":6,"dst_y":12},{"src_x":2,"src_y":12,"dst_x":1,"dst_y":13},{"src_x":4,"src_y":12,"dst_x":3,"dst_y":13},{"src_x":5,"src_y":12,"dst_x":4,"dst_y":13},{"src_x":6,"src_y":12,"dst_x":5,"dst_y":13},{"src_x":1,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":1,"src_y":13,"dst_x":1,"dst_y":14},{"src_x":3,"src_y":13,"dst_x":4,"dst_y":14},{"src_x":4,"src_y":13,"dst_x":4,"dst_y":14},{"src_x":5,"src_y":13,"dst_x":6,"dst_y":14}],"nodes":[{"x":0,"y":0,"class":"MonsterRoom"},{"x":2,"y":0,"class":"MonsterRoom"},{"x":5,"y":0,"class":"MonsterRoom"},{"x":1,"y":1,"class":"MonsterRoom"},{"x":3,"y":1,"class":"MonsterRoom"},{"x":4,"y":1,"class":"EventRoom"},{"x":0,"y":2,"class":"ShopRoom"},{"x":2,"y":2,"class":"MonsterRoom"},{"x":3,"y":2,"class":"EventRoom"},{"x":4,"y":2,"class":"ShopRoom"},{"x":5,"y":2,"class":"EventRoom"},{"x":1,"y":3,"class":"MonsterRoom"},{"x":3,"y":3,"class":"MonsterRoom"},{"x":4,"y":3,"class":"MonsterRoom"},{"x":5,"y":3,"class":"MonsterRoom"},{"x":6,"y":3,"class":"EventRoom"},{"x":1,"y":4,"class":"MonsterRoom"},{"x":3,"y":4,"class":"EventRoom"},{"x":5,"y":4,"class":"MonsterRoom"},{"x":6,"y":4,"class":"EventRoom"},{"x":0,"y":5,"class":"RestRoom"},{"x":2,"y":5,"class":"MonsterRoomElite"},{"x":4,"y":5,"class":"MonsterRoom"},{"x":6,"y":5,"class":"MonsterRoomElite"},{"x":1,"y":6,"class":"MonsterRoomElite"},{"x":2,"y":6,"class":"MonsterRoom"},{"x":5,"y":6,"class":"MonsterRoom"},{"x":6,"y":6,"class":"EventRoom"},{"x":1,"y":7,"class":"MonsterRoom"},{"x":2,"y":7,"class":"MonsterRoomElite"},{"x":4,"y":7,"class":"MonsterRoom"},{"x":5,"y":7,"class":"EventRoom"},{"x":6,"y":7,"class":"MonsterRoom"},{"x":1,"y":8,"class":"TreasureRoom"},{"x":2,"y":8,"class":"TreasureRoom"},{"x":5,"y":8,"class":"TreasureRoom"},{"x":6,"y":8,"class":"TreasureRoom"},{"x":1,"y":9,"class":"MonsterRoom"},{"x":2,"y":9,"class":"RestRoom"},{"x":5,"y":9,"class":"MonsterRoom"},{"x":6,"y":9,"class":"MonsterRoomElite"},{"x":1,"y":10,"class":"MonsterRoom"},{"x":3,"y":10,"class":"MonsterRoom"},{"x":4,"y":10,"class":"RestRoom"},{"x":5,"y":10,"class":"ShopRoom"},{"x":6,"y":10,"class":"RestRoom"},{"x":1,"y":11,"class":"EventRoom"},{"x":3,"y":11,"class":"EventRoom"},{"x":4,"y":11,"class":"MonsterRoomElite"},{"x":5,"y":11,"class":"EventRoom"},{"x":2,"y":12,"class":"RestRoom"},{"x":4,"y":12,"class":"MonsterRoom"},{"x":5,"y":12,"class":"MonsterRoomElite"},{"x":6,"y":12,"class":"EventRoom"},{"x":1,"y":13,"class":"EventRoom"},{"x":3,"y":13,"class":"MonsterRoom"},{"x":4,"y":13,"class":"MonsterRoom"},{"x":5,"y":13,"class":"MonsterRoom"},{"x":0,"y":14,"class":"RestRoom"},{"x":1,"y":14,"class":"RestRoom"},{"x":4,"y":14,"class":"RestRoom"},{"x":6,"y":14,"class":"RestRoom"}]}"#
    );
    assert_eq!(
        dump_map(&maps[1]),
        r#"{"edges":[{"src_x":0,"src_y":0,"dst_x":1,"dst_y":1},{"src_x":1,"src_y":0,"dst_x":2,"dst_y":1},{"src_x":4,"src_y":0,"dst_x":3,"dst_y":1},{"src_x":5,"src_y":0,"dst_x":6,"dst_y":1},{"src_x":1,"src_y":1,"dst_x":0,"dst_y":2},{"src_x":1,"src_y":1,"dst_x":1,"dst_y":2},{"src_x":2,"src_y":1,"dst_x":1,"dst_y":2},{"src_x":2,"src_y":1,"dst_x":2,"dst_y":2},{"src_x":3,"src_y":1,"dst_x":4,"dst_y":2},{"src_x":6,"src_y":1,"dst_x":5,"dst_y":2},{"src_x":0,"src_y":2,"dst_x":0,"dst_y":3},{"src_x":1,"src_y":2,"dst_x":0,"dst_y":3},{"src_x":1,"src_y":2,"dst_x":1,"dst_y":3},{"src_x":2,"src_y":2,"dst_x":3,"dst_y":3},{"src_x":4,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":5,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":0,"src_y":3,"dst_x":0,"dst_y":4},{"src_x":1,"src_y":3,"dst_x":0,"dst_y":4},{"src_x":3,"src_y":3,"dst_x":2,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":5,"dst_y":4},{"src_x":0,"src_y":4,"dst_x":0,"dst_y":5},{"src_x":0,"src_y":4,"dst_x":1,"dst_y":5},{"src_x":2,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":3,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":5,"src_y":4,"dst_x":6,"dst_y":5},{"src_x":0,"src_y":5,"dst_x":0,"dst_y":6},{"src_x":1,"src_y":5,"dst_x":0,"dst_y":6},{"src_x":1,"src_y":5,"dst_x":1,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":1,"dst_y":6},{"src_x":6,"src_y":5,"dst_x":6,"dst_y":6},{"src_x":0,"src_y":6,"dst_x":0,"dst_y":7},{"src_x":0,"src_y":6,"dst_x":1,"dst_y":7},{"src_x":1,"src_y":6,"dst_x":1,"dst_y":7},{"src_x":1,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":6,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":0,"src_y":7,"dst_x":0,"dst_y":8},{"src_x":1,"src_y":7,"dst_x":0,"dst_y":8},{"src_x":1,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":3,"dst_y":8},{"src_x":5,"src_y":7,"dst_x":4,"dst_y":8},{"src_x":0,"src_y":8,"dst_x":0,"dst_y":9},{"src_x":1,"src_y":8,"dst_x":1,"dst_y":9},{"src_x":3,"src_y":8,"dst_x":4,"dst_y":9},{"src_x":4,"src_y":8,"dst_x":4,"dst_y":9},{"src_x":0,"src_y":9,"dst_x":0,"dst_y":10},{"src_x":1,"src_y":9,"dst_x":0,"dst_y":10},{"src_x":1,"src_y":9,"dst_x":2,"dst_y":10},{"src_x":4,"src_y":9,"dst_x":3,"dst_y":10},{"src_x":0,"src_y":10,"dst_x":0,"dst_y":11},{"src_x":0,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":2,"src_y":10,"dst_x":2,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":2,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":4,"dst_y":11},{"src_x":0,"src_y":11,"dst_x":0,"dst_y":12},{"src_x":1,"src_y":11,"dst_x":1,"dst_y":12},{"src_x":2,"src_y":11,"dst_x":1,"dst_y":12},{"src_x":2,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":4,"src_y":11,"dst_x":3,"dst_y":12},{"src_x":0,"src_y":12,"dst_x":0,"dst_y":13},{"src_x":1,"src_y":12,"dst_x":0,"dst_y":13},{"src_x":1,"src_y":12,"dst_x":2,"dst_y":13},{"src_x":2,"src_y":12,"dst_x":2,"dst_y":13},{"src_x":3,"src_y":12,"dst_x":2,"dst_y":13},{"src_x":0,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":0,"src_y":13,"dst_x":1,"dst_y":14},{"src_x":2,"src_y":13,"dst_x":1,"dst_y":14},{"src_x":2,"src_y":13,"dst_x":2,"dst_y":14},{"src_x":2,"src_y":13,"dst_x":3,"dst_y":14}],"nodes":[{"x":0,"y":0,"class":"MonsterRoom"},{"x":1,"y":0,"class":"MonsterRoom"},{"x":4,"y":0,"class":"MonsterRoom"},{"x":5,"y":0,"class":"MonsterRoom"},{"x":1,"y":1,"class":"MonsterRoom"},{"x":2,"y":1,"class":"EventRoom"},{"x":3,"y":1,"class":"EventRoom"},{"x":6,"y":1,"class":"MonsterRoom"},{"x":0,"y":2,"class":"EventRoom"},{"x":1,"y":2,"class":"MonsterRoom"},{"x":2,"y":2,"class":"EventRoom"},{"x":4,"y":2,"class":"MonsterRoom"},{"x":5,"y":2,"class":"MonsterRoom"},{"x":0,"y":3,"class":"EventRoom"},{"x":1,"y":3,"class":"MonsterRoom"},{"x":3,"y":3,"class":"EventRoom"},{"x":4,"y":3,"class":"EventRoom"},{"x":0,"y":4,"class":"MonsterRoom"},{"x":2,"y":4,"class":"MonsterRoom"},{"x":3,"y":4,"class":"ShopRoom"},{"x":5,"y":4,"class":"MonsterRoom"},{"x":0,"y":5,"class":"MonsterRoomElite"},{"x":1,"y":5,"class":"RestRoom"},{"x":2,"y":5,"class":"MonsterRoomElite"},{"x":6,"y":5,"class":"RestRoom"},{"x":0,"y":6,"class":"ShopRoom"},{"x":1,"y":6,"class":"MonsterRoom"},{"x":6,"y":6,"class":"MonsterRoomElite"},{"x":0,"y":7,"class":"RestRoom"},{"x":1,"y":7,"class":"MonsterRoomElite"},{"x":2,"y":7,"class":"RestRoom"},{"x":5,"y":7,"class":"RestRoom"},{"x":0,"y":8,"class":"TreasureRoom"},{"x":1,"y":8,"class":"TreasureRoom"},{"x":3,"y":8,"class":"TreasureRoom"},{"x":4,"y":8,"class":"TreasureRoom"},{"x":0,"y":9,"class":"MonsterRoomElite"},{"x":1,"y":9,"class":"MonsterRoom"},{"x":4,"y":9,"class":"RestRoom"},{"x":0,"y":10,"class":"MonsterRoom"},{"x":2,"y":10,"class":"EventRoom"},{"x":3,"y":10,"class":"MonsterRoom"},{"x":0,"y":11,"class":"EventRoom"},{"x":1,"y":11,"class":"MonsterRoom"},{"x":2,"y":11,"class":"EventRoom"},{"x":4,"y":11,"class":"MonsterRoomElite"},{"x":0,"y":12,"class":"EventRoom"},{"x":1,"y":12,"class":"MonsterRoom"},{"x":2,"y":12,"class":"EventRoom"},{"x":3,"y":12,"class":"MonsterRoom"},{"x":0,"y":13,"class":"MonsterRoomElite"},{"x":2,"y":13,"class":"ShopRoom"},{"x":0,"y":14,"class":"RestRoom"},{"x":1,"y":14,"class":"RestRoom"},{"x":2,"y":14,"class":"RestRoom"},{"x":3,"y":14,"class":"RestRoom"}]}"#
    );
    assert_eq!(
        dump_map(&maps[2]),
        r#"{"edges":[{"src_x":0,"src_y":0,"dst_x":1,"dst_y":1},{"src_x":2,"src_y":0,"dst_x":3,"dst_y":1},{"src_x":5,"src_y":0,"dst_x":4,"dst_y":1},{"src_x":5,"src_y":0,"dst_x":6,"dst_y":1},{"src_x":1,"src_y":1,"dst_x":1,"dst_y":2},{"src_x":3,"src_y":1,"dst_x":4,"dst_y":2},{"src_x":4,"src_y":1,"dst_x":4,"dst_y":2},{"src_x":6,"src_y":1,"dst_x":5,"dst_y":2},{"src_x":6,"src_y":1,"dst_x":6,"dst_y":2},{"src_x":1,"src_y":2,"dst_x":0,"dst_y":3},{"src_x":1,"src_y":2,"dst_x":1,"dst_y":3},{"src_x":4,"src_y":2,"dst_x":3,"dst_y":3},{"src_x":4,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":5,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":6,"src_y":2,"dst_x":5,"dst_y":3},{"src_x":0,"src_y":3,"dst_x":0,"dst_y":4},{"src_x":1,"src_y":3,"dst_x":1,"dst_y":4},{"src_x":3,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":5,"dst_y":4},{"src_x":5,"src_y":3,"dst_x":6,"dst_y":4},{"src_x":0,"src_y":4,"dst_x":0,"dst_y":5},{"src_x":1,"src_y":4,"dst_x":0,"dst_y":5},{"src_x":3,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":5,"src_y":4,"dst_x":4,"dst_y":5},{"src_x":6,"src_y":4,"dst_x":5,"dst_y":5},{"src_x":0,"src_y":5,"dst_x":0,"dst_y":6},{"src_x":0,"src_y":5,"dst_x":1,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":1,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":3,"dst_y":6},{"src_x":4,"src_y":5,"dst_x":3,"dst_y":6},{"src_x":5,"src_y":5,"dst_x":4,"dst_y":6},{"src_x":0,"src_y":6,"dst_x":0,"dst_y":7},{"src_x":1,"src_y":6,"dst_x":1,"dst_y":7},{"src_x":1,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":3,"src_y":6,"dst_x":3,"dst_y":7},{"src_x":4,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":0,"src_y":7,"dst_x":0,"dst_y":8},{"src_x":1,"src_y":7,"dst_x":0,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":3,"src_y":7,"dst_x":2,"dst_y":8},{"src_x":3,"src_y":7,"dst_x":4,"dst_y":8},{"src_x":5,"src_y":7,"dst_x":6,"dst_y":8},{"src_x":0,"src_y":8,"dst_x":1,"dst_y":9},{"src_x":1,"src_y":8,"dst_x":1,"dst_y":9},{"src_x":2,"src_y":8,"dst_x":2,"dst_y":9},{"src_x":4,"src_y":8,"dst_x":4,"dst_y":9},{"src_x":6,"src_y":8,"dst_x":5,"dst_y":9},{"src_x":1,"src_y":9,"dst_x":0,"dst_y":10},{"src_x":1,"src_y":9,"dst_x":1,"dst_y":10},{"src_x":2,"src_y":9,"dst_x":2,"dst_y":10},{"src_x":4,"src_y":9,"dst_x":4,"dst_y":10},{"src_x":5,"src_y":9,"dst_x":5,"dst_y":10},{"src_x":0,"src_y":10,"dst_x":0,"dst_y":11},{"src_x":1,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":2,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":4,"src_y":10,"dst_x":5,"dst_y":11},{"src_x":5,"src_y":10,"dst_x":6,"dst_y":11},{"src_x":0,"src_y":11,"dst_x":0,"dst_y":12},{"src_x":1,"src_y":11,"dst_x":0,"dst_y":12},{"src_x":1,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":5,"src_y":11,"dst_x":5,"dst_y":12},{"src_x":6,"src_y":11,"dst_x":5,"dst_y":12},{"src_x":0,"src_y":12,"dst_x":0,"dst_y":13},{"src_x":0,"src_y":12,"dst_x":1,"dst_y":13},{"src_x":2,"src_y":12,"dst_x":3,"dst_y":13},{"src_x":5,"src_y":12,"dst_x":5,"dst_y":13},{"src_x":5,"src_y":12,"dst_x":6,"dst_y":13},{"src_x":0,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":1,"src_y":13,"dst_x":1,"dst_y":14},{"src_x":3,"src_y":13,"dst_x":4,"dst_y":14},{"src_x":5,"src_y":13,"dst_x":5,"dst_y":14},{"src_x":6,"src_y":13,"dst_x":5,"dst_y":14}],"nodes":[{"x":0,"y":0,"class":"MonsterRoom"},{"x":2,"y":0,"class":"MonsterRoom"},{"x":5,"y":0,"class":"MonsterRoom"},{"x":1,"y":1,"class":"MonsterRoom"},{"x":3,"y":1,"class":"MonsterRoom"},{"x":4,"y":1,"class":"EventRoom"},{"x":6,"y":1,"class":"MonsterRoom"},{"x":1,"y":2,"class":"MonsterRoom"},{"x":4,"y":2,"class":"MonsterRoom"},{"x":5,"y":2,"class":"MonsterRoom"},{"x":6,"y":2,"class":"ShopRoom"},{"x":0,"y":3,"class":"MonsterRoom"},{"x":1,"y":3,"class":"EventRoom"},{"x":3,"y":3,"class":"EventRoom"},{"x":4,"y":3,"class":"MonsterRoom"},{"x":5,"y":3,"class":"MonsterRoom"},{"x":0,"y":4,"class":"EventRoom"},{"x":1,"y":4,"class":"MonsterRoom"},{"x":3,"y":4,"class":"MonsterRoom"},{"x":5,"y":4,"class":"EventRoom"},{"x":6,"y":4,"class":"MonsterRoom"},{"x":0,"y":5,"class":"RestRoom"},{"x":2,"y":5,"class":"MonsterRoomElite"},{"x":4,"y":5,"class":"MonsterRoomElite"},{"x":5,"y":5,"class":"RestRoom"},{"x":0,"y":6,"class":"MonsterRoomElite"},{"x":1,"y":6,"class":"MonsterRoom"},{"x":3,"y":6,"class":"RestRoom"},{"x":4,"y":6,"class":"MonsterRoomElite"},{"x":0,"y":7,"class":"RestRoom"},{"x":1,"y":7,"class":"RestRoom"},{"x":2,"y":7,"class":"ShopRoom"},{"x":3,"y":7,"class":"MonsterRoom"},{"x":5,"y":7,"class":"EventRoom"},{"x":0,"y":8,"class":"TreasureRoom"},{"x":1,"y":8,"class":"TreasureRoom"},{"x":2,"y":8,"class":"TreasureRoom"},{"x":4,"y":8,"class":"TreasureRoom"},{"x":6,"y":8,"class":"TreasureRoom"},{"x":1,"y":9,"class":"EventRoom"},{"x":2,"y":9,"class":"MonsterRoom"},{"x":4,"y":9,"class":"EventRoom"},{"x":5,"y":9,"class":"EventRoom"},{"x":0,"y":10,"class":"MonsterRoom"},{"x":1,"y":10,"class":"MonsterRoomElite"},{"x":2,"y":10,"class":"MonsterRoom"},{"x":4,"y":10,"class":"EventRoom"},{"x":5,"y":10,"class":"EventRoom"},{"x":0,"y":11,"class":"MonsterRoomElite"},{"x":1,"y":11,"class":"MonsterRoom"},{"x":5,"y":11,"class":"MonsterRoom"},{"x":6,"y":11,"class":"MonsterRoom"},{"x":0,"y":12,"class":"ShopRoom"},{"x":2,"y":12,"class":"RestRoom"},{"x":5,"y":12,"class":"MonsterRoomElite"},{"x":0,"y":13,"class":"EventRoom"},{"x":1,"y":13,"class":"MonsterRoomElite"},{"x":3,"y":13,"class":"EventRoom"},{"x":5,"y":13,"class":"MonsterRoom"},{"x":6,"y":13,"class":"MonsterRoom"},{"x":0,"y":14,"class":"RestRoom"},{"x":1,"y":14,"class":"RestRoom"},{"x":4,"y":14,"class":"RestRoom"},{"x":5,"y":14,"class":"RestRoom"}]}"#
    );
}

#[test]
fn check_json_for_other_example() {
    let seed = 2780424839485660359;
    let maps = generate_maps(seed, MAP_HEIGHT, MAP_WIDTH, PATH_DENSITY, IS_ASCENSION_ZERO);
    assert_eq!(
        dump_map(&maps[0]),
        r#"{"edges":[{"src_x":0,"src_y":0,"dst_x":0,"dst_y":1},{"src_x":3,"src_y":0,"dst_x":4,"dst_y":1},{"src_x":4,"src_y":0,"dst_x":5,"dst_y":1},{"src_x":0,"src_y":1,"dst_x":1,"dst_y":2},{"src_x":4,"src_y":1,"dst_x":5,"dst_y":2},{"src_x":5,"src_y":1,"dst_x":5,"dst_y":2},{"src_x":5,"src_y":1,"dst_x":6,"dst_y":2},{"src_x":1,"src_y":2,"dst_x":2,"dst_y":3},{"src_x":5,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":5,"src_y":2,"dst_x":5,"dst_y":3},{"src_x":6,"src_y":2,"dst_x":5,"dst_y":3},{"src_x":2,"src_y":3,"dst_x":1,"dst_y":4},{"src_x":2,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":3,"dst_y":4},{"src_x":5,"src_y":3,"dst_x":5,"dst_y":4},{"src_x":5,"src_y":3,"dst_x":6,"dst_y":4},{"src_x":1,"src_y":4,"dst_x":1,"dst_y":5},{"src_x":3,"src_y":4,"dst_x":3,"dst_y":5},{"src_x":5,"src_y":4,"dst_x":4,"dst_y":5},{"src_x":5,"src_y":4,"dst_x":5,"dst_y":5},{"src_x":6,"src_y":4,"dst_x":5,"dst_y":5},{"src_x":1,"src_y":5,"dst_x":2,"dst_y":6},{"src_x":3,"src_y":5,"dst_x":2,"dst_y":6},{"src_x":3,"src_y":5,"dst_x":4,"dst_y":6},{"src_x":4,"src_y":5,"dst_x":4,"dst_y":6},{"src_x":5,"src_y":5,"dst_x":4,"dst_y":6},{"src_x":2,"src_y":6,"dst_x":1,"dst_y":7},{"src_x":2,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":4,"src_y":6,"dst_x":4,"dst_y":7},{"src_x":4,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":1,"src_y":7,"dst_x":2,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":2,"dst_y":8},{"src_x":4,"src_y":7,"dst_x":3,"dst_y":8},{"src_x":4,"src_y":7,"dst_x":4,"dst_y":8},{"src_x":4,"src_y":7,"dst_x":5,"dst_y":8},{"src_x":5,"src_y":7,"dst_x":6,"dst_y":8},{"src_x":2,"src_y":8,"dst_x":2,"dst_y":9},{"src_x":3,"src_y":8,"dst_x":2,"dst_y":9},{"src_x":4,"src_y":8,"dst_x":5,"dst_y":9},{"src_x":5,"src_y":8,"dst_x":6,"dst_y":9},{"src_x":6,"src_y":8,"dst_x":6,"dst_y":9},{"src_x":2,"src_y":9,"dst_x":1,"dst_y":10},{"src_x":2,"src_y":9,"dst_x":3,"dst_y":10},{"src_x":5,"src_y":9,"dst_x":6,"dst_y":10},{"src_x":6,"src_y":9,"dst_x":6,"dst_y":10},{"src_x":1,"src_y":10,"dst_x":0,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":3,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":4,"dst_y":11},{"src_x":6,"src_y":10,"dst_x":5,"dst_y":11},{"src_x":6,"src_y":10,"dst_x":6,"dst_y":11},{"src_x":0,"src_y":11,"dst_x":1,"dst_y":12},{"src_x":3,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":4,"src_y":11,"dst_x":5,"dst_y":12},{"src_x":5,"src_y":11,"dst_x":6,"dst_y":12},{"src_x":6,"src_y":11,"dst_x":6,"dst_y":12},{"src_x":1,"src_y":12,"dst_x":1,"dst_y":13},{"src_x":2,"src_y":12,"dst_x":2,"dst_y":13},{"src_x":5,"src_y":12,"dst_x":5,"dst_y":13},{"src_x":6,"src_y":12,"dst_x":5,"dst_y":13},{"src_x":1,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":2,"src_y":13,"dst_x":2,"dst_y":14},{"src_x":5,"src_y":13,"dst_x":4,"dst_y":14},{"src_x":5,"src_y":13,"dst_x":5,"dst_y":14},{"src_x":5,"src_y":13,"dst_x":6,"dst_y":14}],"nodes":[{"x":0,"y":0,"class":"MonsterRoom"},{"x":3,"y":0,"class":"MonsterRoom"},{"x":4,"y":0,"class":"MonsterRoom"},{"x":0,"y":1,"class":"MonsterRoom"},{"x":4,"y":1,"class":"EventRoom"},{"x":5,"y":1,"class":"EventRoom"},{"x":1,"y":2,"class":"ShopRoom"},{"x":5,"y":2,"class":"EventRoom"},{"x":6,"y":2,"class":"ShopRoom"},{"x":2,"y":3,"class":"MonsterRoom"},{"x":4,"y":3,"class":"EventRoom"},{"x":5,"y":3,"class":"MonsterRoom"},{"x":1,"y":4,"class":"EventRoom"},{"x":3,"y":4,"class":"MonsterRoom"},{"x":5,"y":4,"class":"EventRoom"},{"x":6,"y":4,"class":"MonsterRoom"},{"x":1,"y":5,"class":"RestRoom"},{"x":3,"y":5,"class":"MonsterRoomElite"},{"x":4,"y":5,"class":"MonsterRoomElite"},{"x":5,"y":5,"class":"RestRoom"},{"x":2,"y":6,"class":"MonsterRoom"},{"x":4,"y":6,"class":"EventRoom"},{"x":1,"y":7,"class":"MonsterRoomElite"},{"x":2,"y":7,"class":"RestRoom"},{"x":4,"y":7,"class":"MonsterRoomElite"},{"x":5,"y":7,"class":"MonsterRoom"},{"x":2,"y":8,"class":"TreasureRoom"},{"x":3,"y":8,"class":"TreasureRoom"},{"x":4,"y":8,"class":"TreasureRoom"},{"x":5,"y":8,"class":"TreasureRoom"},{"x":6,"y":8,"class":"TreasureRoom"},{"x":2,"y":9,"class":"MonsterRoomElite"},{"x":5,"y":9,"class":"MonsterRoomElite"},{"x":6,"y":9,"class":"ShopRoom"},{"x":1,"y":10,"class":"EventRoom"},{"x":3,"y":10,"class":"MonsterRoom"},{"x":6,"y":10,"class":"EventRoom"},{"x":0,"y":11,"class":"MonsterRoomElite"},{"x":3,"y":11,"class":"EventRoom"},{"x":4,"y":11,"class":"MonsterRoom"},{"x":5,"y":11,"class":"MonsterRoom"},{"x":6,"y":11,"class":"RestRoom"},{"x":1,"y":12,"class":"MonsterRoom"},{"x":2,"y":12,"class":"MonsterRoom"},{"x":5,"y":12,"class":"MonsterRoom"},{"x":6,"y":12,"class":"MonsterRoom"},{"x":1,"y":13,"class":"EventRoom"},{"x":2,"y":13,"class":"MonsterRoom"},{"x":5,"y":13,"class":"MonsterRoom"},{"x":0,"y":14,"class":"RestRoom"},{"x":2,"y":14,"class":"RestRoom"},{"x":4,"y":14,"class":"RestRoom"},{"x":5,"y":14,"class":"RestRoom"},{"x":6,"y":14,"class":"RestRoom"}]}"#
    );
    assert_eq!(
        dump_map(&maps[1]),
        r#"{"edges":[{"src_x":0,"src_y":0,"dst_x":0,"dst_y":1},{"src_x":1,"src_y":0,"dst_x":1,"dst_y":1},{"src_x":3,"src_y":0,"dst_x":3,"dst_y":1},{"src_x":6,"src_y":0,"dst_x":5,"dst_y":1},{"src_x":0,"src_y":1,"dst_x":1,"dst_y":2},{"src_x":1,"src_y":1,"dst_x":1,"dst_y":2},{"src_x":1,"src_y":1,"dst_x":2,"dst_y":2},{"src_x":3,"src_y":1,"dst_x":4,"dst_y":2},{"src_x":5,"src_y":1,"dst_x":6,"dst_y":2},{"src_x":1,"src_y":2,"dst_x":0,"dst_y":3},{"src_x":1,"src_y":2,"dst_x":1,"dst_y":3},{"src_x":2,"src_y":2,"dst_x":1,"dst_y":3},{"src_x":4,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":6,"src_y":2,"dst_x":6,"dst_y":3},{"src_x":0,"src_y":3,"dst_x":1,"dst_y":4},{"src_x":1,"src_y":3,"dst_x":1,"dst_y":4},{"src_x":1,"src_y":3,"dst_x":2,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":5,"dst_y":4},{"src_x":6,"src_y":3,"dst_x":6,"dst_y":4},{"src_x":1,"src_y":4,"dst_x":0,"dst_y":5},{"src_x":1,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":2,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":5,"src_y":4,"dst_x":5,"dst_y":5},{"src_x":6,"src_y":4,"dst_x":5,"dst_y":5},{"src_x":0,"src_y":5,"dst_x":0,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":2,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":3,"dst_y":6},{"src_x":5,"src_y":5,"dst_x":4,"dst_y":6},{"src_x":5,"src_y":5,"dst_x":5,"dst_y":6},{"src_x":0,"src_y":6,"dst_x":0,"dst_y":7},{"src_x":2,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":3,"src_y":6,"dst_x":3,"dst_y":7},{"src_x":3,"src_y":6,"dst_x":4,"dst_y":7},{"src_x":4,"src_y":6,"dst_x":4,"dst_y":7},{"src_x":5,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":0,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":3,"src_y":7,"dst_x":4,"dst_y":8},{"src_x":4,"src_y":7,"dst_x":4,"dst_y":8},{"src_x":4,"src_y":7,"dst_x":5,"dst_y":8},{"src_x":5,"src_y":7,"dst_x":5,"dst_y":8},{"src_x":1,"src_y":8,"dst_x":0,"dst_y":9},{"src_x":1,"src_y":8,"dst_x":1,"dst_y":9},{"src_x":4,"src_y":8,"dst_x":3,"dst_y":9},{"src_x":5,"src_y":8,"dst_x":6,"dst_y":9},{"src_x":0,"src_y":9,"dst_x":0,"dst_y":10},{"src_x":1,"src_y":9,"dst_x":1,"dst_y":10},{"src_x":3,"src_y":9,"dst_x":3,"dst_y":10},{"src_x":3,"src_y":9,"dst_x":4,"dst_y":10},{"src_x":6,"src_y":9,"dst_x":5,"dst_y":10},{"src_x":6,"src_y":9,"dst_x":6,"dst_y":10},{"src_x":0,"src_y":10,"dst_x":0,"dst_y":11},{"src_x":1,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":4,"dst_y":11},{"src_x":4,"src_y":10,"dst_x":4,"dst_y":11},{"src_x":5,"src_y":10,"dst_x":4,"dst_y":11},{"src_x":6,"src_y":10,"dst_x":5,"dst_y":11},{"src_x":0,"src_y":11,"dst_x":1,"dst_y":12},{"src_x":1,"src_y":11,"dst_x":1,"dst_y":12},{"src_x":4,"src_y":11,"dst_x":4,"dst_y":12},{"src_x":5,"src_y":11,"dst_x":4,"dst_y":12},{"src_x":1,"src_y":12,"dst_x":1,"dst_y":13},{"src_x":1,"src_y":12,"dst_x":2,"dst_y":13},{"src_x":4,"src_y":12,"dst_x":3,"dst_y":13},{"src_x":4,"src_y":12,"dst_x":4,"dst_y":13},{"src_x":4,"src_y":12,"dst_x":5,"dst_y":13},{"src_x":1,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":2,"src_y":13,"dst_x":1,"dst_y":14},{"src_x":3,"src_y":13,"dst_x":3,"dst_y":14},{"src_x":4,"src_y":13,"dst_x":3,"dst_y":14},{"src_x":5,"src_y":13,"dst_x":5,"dst_y":14}],"nodes":[{"x":0,"y":0,"class":"MonsterRoom"},{"x":1,"y":0,"class":"MonsterRoom"},{"x":3,"y":0,"class":"MonsterRoom"},{"x":6,"y":0,"class":"MonsterRoom"},{"x":0,"y":1,"class":"MonsterRoom"},{"x":1,"y":1,"class":"MonsterRoom"},{"x":3,"y":1,"class":"MonsterRoom"},{"x":5,"y":1,"class":"MonsterRoom"},{"x":1,"y":2,"class":"EventRoom"},{"x":2,"y":2,"class":"MonsterRoom"},{"x":4,"y":2,"class":"EventRoom"},{"x":6,"y":2,"class":"MonsterRoom"},{"x":0,"y":3,"class":"EventRoom"},{"x":1,"y":3,"class":"MonsterRoom"},{"x":4,"y":3,"class":"EventRoom"},{"x":6,"y":3,"class":"EventRoom"},{"x":1,"y":4,"class":"EventRoom"},{"x":2,"y":4,"class":"ShopRoom"},{"x":5,"y":4,"class":"MonsterRoom"},{"x":6,"y":4,"class":"MonsterRoom"},{"x":0,"y":5,"class":"RestRoom"},{"x":2,"y":5,"class":"MonsterRoomElite"},{"x":5,"y":5,"class":"RestRoom"},{"x":0,"y":6,"class":"MonsterRoomElite"},{"x":2,"y":6,"class":"RestRoom"},{"x":3,"y":6,"class":"EventRoom"},{"x":4,"y":6,"class":"MonsterRoomElite"},{"x":5,"y":6,"class":"MonsterRoom"},{"x":0,"y":7,"class":"RestRoom"},{"x":2,"y":7,"class":"MonsterRoom"},{"x":3,"y":7,"class":"MonsterRoom"},{"x":4,"y":7,"class":"EventRoom"},{"x":5,"y":7,"class":"MonsterRoomElite"},{"x":1,"y":8,"class":"TreasureRoom"},{"x":4,"y":8,"class":"TreasureRoom"},{"x":5,"y":8,"class":"TreasureRoom"},{"x":0,"y":9,"class":"MonsterRoom"},{"x":1,"y":9,"class":"MonsterRoomElite"},{"x":3,"y":9,"class":"MonsterRoom"},{"x":6,"y":9,"class":"MonsterRoom"},{"x":0,"y":10,"class":"MonsterRoom"},{"x":1,"y":10,"class":"MonsterRoom"},{"x":3,"y":10,"class":"MonsterRoomElite"},{"x":4,"y":10,"class":"MonsterRoom"},{"x":5,"y":10,"class":"MonsterRoom"},{"x":6,"y":10,"class":"EventRoom"},{"x":0,"y":11,"class":"RestRoom"},{"x":1,"y":11,"class":"EventRoom"},{"x":4,"y":11,"class":"MonsterRoom"},{"x":5,"y":11,"class":"RestRoom"},{"x":1,"y":12,"class":"MonsterRoom"},{"x":4,"y":12,"class":"ShopRoom"},{"x":1,"y":13,"class":"EventRoom"},{"x":2,"y":13,"class":"MonsterRoomElite"},{"x":3,"y":13,"class":"EventRoom"},{"x":4,"y":13,"class":"MonsterRoom"},{"x":5,"y":13,"class":"MonsterRoom"},{"x":0,"y":14,"class":"RestRoom"},{"x":1,"y":14,"class":"RestRoom"},{"x":3,"y":14,"class":"RestRoom"},{"x":5,"y":14,"class":"RestRoom"}]}"#
    );
    assert_eq!(
        dump_map(&maps[2]),
        r#"{"edges":[{"src_x":0,"src_y":0,"dst_x":0,"dst_y":1},{"src_x":1,"src_y":0,"dst_x":1,"dst_y":1},{"src_x":4,"src_y":0,"dst_x":5,"dst_y":1},{"src_x":0,"src_y":1,"dst_x":0,"dst_y":2},{"src_x":1,"src_y":1,"dst_x":0,"dst_y":2},{"src_x":5,"src_y":1,"dst_x":4,"dst_y":2},{"src_x":5,"src_y":1,"dst_x":5,"dst_y":2},{"src_x":5,"src_y":1,"dst_x":6,"dst_y":2},{"src_x":0,"src_y":2,"dst_x":1,"dst_y":3},{"src_x":4,"src_y":2,"dst_x":4,"dst_y":3},{"src_x":5,"src_y":2,"dst_x":5,"dst_y":3},{"src_x":6,"src_y":2,"dst_x":5,"dst_y":3},{"src_x":1,"src_y":3,"dst_x":0,"dst_y":4},{"src_x":1,"src_y":3,"dst_x":1,"dst_y":4},{"src_x":4,"src_y":3,"dst_x":4,"dst_y":4},{"src_x":5,"src_y":3,"dst_x":4,"dst_y":4},{"src_x":5,"src_y":3,"dst_x":6,"dst_y":4},{"src_x":0,"src_y":4,"dst_x":0,"dst_y":5},{"src_x":1,"src_y":4,"dst_x":1,"dst_y":5},{"src_x":1,"src_y":4,"dst_x":2,"dst_y":5},{"src_x":4,"src_y":4,"dst_x":3,"dst_y":5},{"src_x":4,"src_y":4,"dst_x":4,"dst_y":5},{"src_x":6,"src_y":4,"dst_x":5,"dst_y":5},{"src_x":0,"src_y":5,"dst_x":1,"dst_y":6},{"src_x":1,"src_y":5,"dst_x":2,"dst_y":6},{"src_x":2,"src_y":5,"dst_x":2,"dst_y":6},{"src_x":3,"src_y":5,"dst_x":3,"dst_y":6},{"src_x":4,"src_y":5,"dst_x":5,"dst_y":6},{"src_x":5,"src_y":5,"dst_x":5,"dst_y":6},{"src_x":1,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":2,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":3,"src_y":6,"dst_x":2,"dst_y":7},{"src_x":5,"src_y":6,"dst_x":5,"dst_y":7},{"src_x":2,"src_y":7,"dst_x":1,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":2,"dst_y":8},{"src_x":2,"src_y":7,"dst_x":3,"dst_y":8},{"src_x":5,"src_y":7,"dst_x":5,"dst_y":8},{"src_x":1,"src_y":8,"dst_x":0,"dst_y":9},{"src_x":2,"src_y":8,"dst_x":1,"dst_y":9},{"src_x":2,"src_y":8,"dst_x":2,"dst_y":9},{"src_x":3,"src_y":8,"dst_x":3,"dst_y":9},{"src_x":5,"src_y":8,"dst_x":4,"dst_y":9},{"src_x":5,"src_y":8,"dst_x":5,"dst_y":9},{"src_x":0,"src_y":9,"dst_x":0,"dst_y":10},{"src_x":1,"src_y":9,"dst_x":0,"dst_y":10},{"src_x":2,"src_y":9,"dst_x":1,"dst_y":10},{"src_x":3,"src_y":9,"dst_x":2,"dst_y":10},{"src_x":4,"src_y":9,"dst_x":3,"dst_y":10},{"src_x":5,"src_y":9,"dst_x":5,"dst_y":10},{"src_x":0,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":1,"src_y":10,"dst_x":1,"dst_y":11},{"src_x":2,"src_y":10,"dst_x":2,"dst_y":11},{"src_x":3,"src_y":10,"dst_x":3,"dst_y":11},{"src_x":5,"src_y":10,"dst_x":6,"dst_y":11},{"src_x":1,"src_y":11,"dst_x":0,"dst_y":12},{"src_x":1,"src_y":11,"dst_x":1,"dst_y":12},{"src_x":1,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":2,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":3,"src_y":11,"dst_x":2,"dst_y":12},{"src_x":6,"src_y":11,"dst_x":6,"dst_y":12},{"src_x":0,"src_y":12,"dst_x":0,"dst_y":13},{"src_x":1,"src_y":12,"dst_x":1,"dst_y":13},{"src_x":2,"src_y":12,"dst_x":1,"dst_y":13},{"src_x":2,"src_y":12,"dst_x":2,"dst_y":13},{"src_x":2,"src_y":12,"dst_x":3,"dst_y":13},{"src_x":6,"src_y":12,"dst_x":6,"dst_y":13},{"src_x":0,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":1,"src_y":13,"dst_x":0,"dst_y":14},{"src_x":1,"src_y":13,"dst_x":2,"dst_y":14},{"src_x":2,"src_y":13,"dst_x":2,"dst_y":14},{"src_x":3,"src_y":13,"dst_x":4,"dst_y":14},{"src_x":6,"src_y":13,"dst_x":6,"dst_y":14}],"nodes":[{"x":0,"y":0,"class":"MonsterRoom"},{"x":1,"y":0,"class":"MonsterRoom"},{"x":4,"y":0,"class":"MonsterRoom"},{"x":0,"y":1,"class":"EventRoom"},{"x":1,"y":1,"class":"ShopRoom"},{"x":5,"y":1,"class":"MonsterRoom"},{"x":0,"y":2,"class":"MonsterRoom"},{"x":4,"y":2,"class":"MonsterRoom"},{"x":5,"y":2,"class":"EventRoom"},{"x":6,"y":2,"class":"ShopRoom"},{"x":1,"y":3,"class":"MonsterRoom"},{"x":4,"y":3,"class":"MonsterRoom"},{"x":5,"y":3,"class":"MonsterRoom"},{"x":0,"y":4,"class":"MonsterRoom"},{"x":1,"y":4,"class":"EventRoom"},{"x":4,"y":4,"class":"MonsterRoom"},{"x":6,"y":4,"class":"EventRoom"},{"x":0,"y":5,"class":"RestRoom"},{"x":1,"y":5,"class":"RestRoom"},{"x":2,"y":5,"class":"MonsterRoomElite"},{"x":3,"y":5,"class":"RestRoom"},{"x":4,"y":5,"class":"MonsterRoom"},{"x":5,"y":5,"class":"RestRoom"},{"x":1,"y":6,"class":"MonsterRoomElite"},{"x":2,"y":6,"class":"MonsterRoom"},{"x":3,"y":6,"class":"MonsterRoom"},{"x":5,"y":6,"class":"EventRoom"},{"x":2,"y":7,"class":"MonsterRoom"},{"x":5,"y":7,"class":"MonsterRoom"},{"x":1,"y":8,"class":"TreasureRoom"},{"x":2,"y":8,"class":"TreasureRoom"},{"x":3,"y":8,"class":"TreasureRoom"},{"x":5,"y":8,"class":"TreasureRoom"},{"x":0,"y":9,"class":"EventRoom"},{"x":1,"y":9,"class":"MonsterRoom"},{"x":2,"y":9,"class":"EventRoom"},{"x":3,"y":9,"class":"MonsterRoom"},{"x":4,"y":9,"class":"MonsterRoom"},{"x":5,"y":9,"class":"RestRoom"},{"x":0,"y":10,"class":"MonsterRoom"},{"x":1,"y":10,"class":"MonsterRoom"},{"x":2,"y":10,"class":"EventRoom"},{"x":3,"y":10,"class":"EventRoom"},{"x":5,"y":10,"class":"EventRoom"},{"x":1,"y":11,"class":"RestRoom"},{"x":2,"y":11,"class":"MonsterRoomElite"},{"x":3,"y":11,"class":"RestRoom"},{"x":6,"y":11,"class":"MonsterRoom"},{"x":0,"y":12,"class":"MonsterRoom"},{"x":1,"y":12,"class":"EventRoom"},{"x":2,"y":12,"class":"ShopRoom"},{"x":6,"y":12,"class":"MonsterRoom"},{"x":0,"y":13,"class":"MonsterRoomElite"},{"x":1,"y":13,"class":"MonsterRoomElite"},{"x":2,"y":13,"class":"EventRoom"},{"x":3,"y":13,"class":"MonsterRoom"},{"x":6,"y":13,"class":"MonsterRoomElite"},{"x":0,"y":14,"class":"RestRoom"},{"x":2,"y":14,"class":"RestRoom"},{"x":4,"y":14,"class":"RestRoom"},{"x":6,"y":14,"class":"RestRoom"}]}"#
    );
}

#[test]
fn check_output_for_readme_example() {
    let seed = 673465884448;
    let maps = generate_maps(seed, MAP_HEIGHT, MAP_WIDTH, PATH_DENSITY, IS_ASCENSION_ZERO);
    assert_eq!(format_map(&maps[0]), "\n                           \n14     R  R        R     R \n         \\|      / |   /   \n13        ?     M  M  M    \n            \\     \\  \\  \\  \n12           R     M  E  ? \n           /   \\   |  |/   \n11        ?     ?  E  ?    \n          |     |  |  | \\  \n10        M     M  R  $  R \n          |   /      \\|  | \n9         M  R        M  E \n          |  |        |/ | \n8         T  T        T  T \n          |  |      / |  | \n7         M  E     M  ?  M \n          |  |       \\| \\| \n6         E  M        M  ? \n        /    |      /   \\| \n5      R     E     M     E \n         \\     \\ /     / | \n4         M     ?     M  ? \n          |     | \\ /  / | \n3         M     M  M  M  ? \n        /     /  /  /  /   \n2      $     M  ?  $  ?    \n         \\     \\|/  /      \n1         M     M  ?       \n        /     /      \\     \n0      M     M        M    ");
    assert_eq!(format_map(&maps[1]), "\n                           \n14     R  R  R  R          \n       |/   \\|/            \n13     E     $             \n       | \\ / | \\           \n12     ?  M  ?  M          \n       |  | \\|    \\        \n11     ?  M  ?     E       \n       |/    | \\ /         \n10     M     ?  M          \n       | \\ /      \\        \n9      E  M        R       \n       |  |      / |       \n8      T  T     T  T       \n       | \\| \\ /      \\     \n7      R  E  R        R    \n       |/ |/            \\  \n6      $  M              E \n       | \\| \\            | \n5      E  R  E           R \n       |/    | \\       /   \n4      M     M  $     M    \n       | \\     \\  \\ /      \n3      ?  M     ?  ?       \n       | \\|   /    | \\     \n2      ?  M  ?     M  M    \n         \\| \\|   /      \\  \n1         M  ?  ?        M \n        /  /      \\    /   \n0      M  M        M  M    ");
    assert_eq!(format_map(&maps[2]), "\n                           \n14     R  R        R  R    \n       |  |      /    | \\  \n13     ?  E     ?     M  M \n       |/     /       |/   \n12     $     R        E    \n       | \\ /          | \\  \n11     E  M           M  M \n       |  | \\       /  /   \n10     M  E  M     ?  ?    \n         \\|  |     |  |    \n9         ?  M     ?  ?    \n        / |  |     |    \\  \n8      T  T  T     T     T \n       | \\  \\  \\ /     /   \n7      R  R  $  M     ?    \n       |  |/    |   /      \n6      E  M     R  E       \n       |/   \\ /   \\  \\     \n5      R     E     E  R    \n       | \\     \\     \\  \\  \n4      ?  M     M     ?  M \n       |  |     | \\ /  /   \n3      M  ?     ?  M  M    \n         \\|       \\| \\  \\  \n2         M        M  M  $ \n          |      / |    \\| \n1         M     M  ?     M \n        /     /      \\ /   \n0      M     M        M    ");
}

#[test]
fn check_output_for_other_example() {
    let seed = 2780424839485660359;
    let maps = generate_maps(seed, MAP_HEIGHT, MAP_WIDTH, PATH_DENSITY, IS_ASCENSION_ZERO);
    assert_eq!(format_map(&maps[0]), "\n                           \n14     R     R     R  R  R \n         \\   |       \\|/   \n13        ?  M        M    \n          |  |        | \\  \n12        M  M        M  M \n        /      \\    /  / | \n11     E        ?  M  M  R \n         \\      |/      \\| \n10        ?     M        ? \n            \\ /        / | \n9            E        E  $ \n             | \\    /  / | \n8            T  T  T  T  T \n           / |    \\|/  /   \n7         E  R     E  M    \n            \\|     |/      \n6            M     ?       \n           /   \\ / | \\     \n5         R     E  E  R    \n          |     |    \\| \\  \n4         ?     M     ?  M \n            \\ /   \\   |/   \n3            M     ?  M    \n           /         \\| \\  \n2         $           ?  $ \n        /           / |/   \n1      M           ?  ?    \n       |         /  /      \n0      M        M  M       ");
    assert_eq!(format_map(&maps[1]), "\n                           \n14     R  R     R     R    \n         \\  \\   | \\   |    \n13        ?  E  ?  M  M    \n          |/      \\|/      \n12        M        $       \n        / |        | \\     \n11     R  ?        M  R    \n       |  |      / | \\  \\  \n10     M  M     E  M  M  ? \n       |  |     |/      \\| \n9      M  E     M        M \n         \\|       \\    /   \n8         T        T  T    \n        /   \\    / |/ |    \n7      R     M  M  ?  E    \n       |     |  |/ |  |    \n6      E     R  ?  E  M    \n       |     |/      \\|    \n5      R     E        R    \n         \\ / |        | \\  \n4         ?  $        M  M \n        / |/        /    | \n3      ?  M        ?     ? \n         \\| \\      |     | \n2         ?  M     ?     M \n        / |/     /     /   \n1      M  M     M     M    \n       |  |     |       \\  \n0      M  M     M        M ");
    assert_eq!(format_map(&maps[2]), "\n                           \n14     R     R     R     R \n       | \\ / |   /       | \n13     E  E  ?  M        E \n       |  | \\|/          | \n12     M  ?  $           M \n         \\|/ | \\         | \n11        R  E  R        M \n        / |  |  |      /   \n10     M  M  ?  ?     ?    \n       | \\  \\  \\  \\   |    \n9      ?  M  ?  M  M  R    \n         \\  \\|  |    \\|    \n8         T  T  T     T    \n            \\|/       |    \n7            M        M    \n           / | \\      |    \n6         E  M  M     ?    \n        /  / |  |   / |    \n5      R  R  E  R  M  R    \n       |  |/      \\|    \\  \n4      M  ?        M     ? \n         \\|        | \\ /   \n3         M        M  M    \n        /          |  | \\  \n2      M           M  ?  $ \n       | \\           \\|/   \n1      ?  $           M    \n       |  |         /      \n0      M  M        M       ");
}
